package XButtler::GtkMain;

use strict;
use XButtler::Common;
use Gtk;

use vars qw(@EXPORT @ISA);
require Exporter;

@ISA = qw(Exporter);
@EXPORT = qw (
	OFFER_CLIST_NETWORK
	OFFER_CLIST_BOT
	OFFER_CLIST_PACK
	OFFER_CLIST_SLOTS
	OFFER_CLIST_QUEUE
	OFFER_CLIST_SIZE
	OFFER_CLIST_DESCRIPTION
	OFFER_CLIST_DEFAULT_SORT
	QUEUE_CLIST_NETWORK
	QUEUE_CLIST_BOT
	QUEUE_CLIST_PACK
	QUEUE_CLIST_STATE
	QUEUE_CLIST_DESCRIPTION
	QUEUE_CLIST_DEFAULT_SORT
	DCC_CLIST_ID
	DCC_CLIST_BOT
	DCC_CLIST_FILE
	DCC_CLIST_SIZE
	DCC_CLIST_PERCENT
	DCC_CLIST_SPEED
	DCC_CLIST_ETA
	DCC_CLIST_DEFAULT_SORT
	NETWORK_CLIST_NETWORK
	NETWORK_CLIST_STATUS
	NETWORK_CLIST_CHANNELS
	NETWORK_CLIST_INFO
	NETWORK_CLIST_DEFAULT_SORT
	CHANNEL_CLIST_NETWORK
	CHANNEL_CLIST_CHANNEL
	CHANNEL_CLIST_STATUS
	CHANNEL_CLIST_TOPIC
	CHANNEL_CLIST_DEFAULT_SORT
);

# offer clist rows
use constant OFFER_CLIST_NETWORK	=> 0;
use constant OFFER_CLIST_BOT		=> 1;
use constant OFFER_CLIST_PACK		=> 2;
use constant OFFER_CLIST_SLOTS		=> 3;
use constant OFFER_CLIST_QUEUE		=> 4;
use constant OFFER_CLIST_SIZE		=> 5;
use constant OFFER_CLIST_DESCRIPTION	=> 6;
use constant OFFER_CLIST_DEFAULT_SORT	=> OFFER_CLIST_DESCRIPTION;

# queue clist rows
use constant QUEUE_CLIST_NETWORK	=> 0;
use constant QUEUE_CLIST_BOT		=> 1;
use constant QUEUE_CLIST_PACK		=> 2;
use constant QUEUE_CLIST_STATE		=> 3;
use constant QUEUE_CLIST_DESCRIPTION	=> 4;
use constant QUEUE_CLIST_DEFAULT_SORT	=> QUEUE_CLIST_STATE;

# dcc clist rows
use constant DCC_CLIST_ID		=> 0;
use constant DCC_CLIST_BOT		=> 1;
use constant DCC_CLIST_FILE		=> 2;
use constant DCC_CLIST_SIZE		=> 3;
use constant DCC_CLIST_PERCENT		=> 4;
use constant DCC_CLIST_SPEED		=> 5;
use constant DCC_CLIST_ETA		=> 6;
use constant DCC_CLIST_DEFAULT_SORT	=> DCC_CLIST_SPEED;

# network clist rows
use constant NETWORK_CLIST_NETWORK	=> 0;
use constant NETWORK_CLIST_STATUS	=> 1;
use constant NETWORK_CLIST_CHANNELS	=> 2;
use constant NETWORK_CLIST_INFO		=> 4;
use constant NETWORK_CLIST_DEFAULT_SORT	=> NETWORK_CLIST_NETWORK;

# channel clist rows
use constant CHANNEL_CLIST_NETWORK	=> 0;
use constant CHANNEL_CLIST_CHANNEL	=> 1;
use constant CHANNEL_CLIST_STATUS	=> 2;
use constant CHANNEL_CLIST_TOPIC	=> 3;
use constant CHANNEL_CLIST_DEFAULT_SORT	=> CHANNEL_CLIST_STATUS;

sub new {
	my $self = {};
	my ($frame,$menubar,$menuitem,$menu,$label,$vbox,$hbox,$packer,$swindow,$notebook,$sbar);
	
	$self->{'WINDOW'} = new Gtk::Window("toplevel");
	$self->{'WINDOW'}->set_title("Buttler");
	$self->{'WINDOW'}->position("none");
	$self->{'WINDOW'}->set_policy(FALSE, TRUE, FALSE );
	$self->{'WINDOW'}->set_modal(FALSE);
	$self->{'WINDOW'}->set_usize(800,640);
	$self->{'WINDOW'}->realize();
	  my $vbox = new Gtk::VBox(FALSE,0);
	    # menubar
	    $menubar = new Gtk::MenuBar();
	    $menubar->set_shadow_type('out');
	      $menuitem = new Gtk::MenuItem("File");
	        my $menu = new Gtk::Menu;
	        $self->{'FILE_MENU'}->{'EXIT'} = new Gtk::MenuItem("Exit");
	        $menu->append($self->{'FILE_MENU'}->{'EXIT'});
		$self->{'FILE_MENU'}->{'EXIT'}->show();
	        $menuitem->set_submenu($menu);
	#        $menu->show();
	      $menubar->append($menuitem);
	      $menuitem->show();   
		# add menuitems here
	    $menubar->show();
	    $vbox->add($menubar);
	    $vbox->set_child_packing($menubar,0,0,0,"start");
	    
	    # Status Frame
	    $frame = new Gtk::Frame("Status");
	    $frame->set_label_align(0.01,0);
	    $frame->set_shadow_type('etched_in');
	    $frame->border_width(5);
	      $packer = new Gtk::Packer();
	      $packer->set_default_border_width(2);
	      $packer->set_default_pad(3,3);
	      $packer->set_default_ipad(1,0);
	      $packer->border_width(6);
	      $frame->add($packer);
	        $hbox = new Gtk::HBox(FALSE,FALSE);
	        $packer->add_defaults($hbox,"top","north_west",["expand","fill_x","fill_y"]);
	          $swindow = new Gtk::ScrolledWindow(undef,undef);
	          $swindow->set_policy("automatic","always");
	          $swindow->border_width(0);
	          $swindow->hscrollbar->set_update_policy('continuous');
	          $swindow->vscrollbar->set_update_policy('continuous');
	          $swindow->set_usize(75,50);
	          $hbox->add($swindow);
	            $self->{'STATUS_TEXT'} = new Gtk::Text(undef,undef);
	            $self->{'STATUS_TEXT'}->set_editable(0);
	            $self->{'STATUS_TEXT'}->can_focus(1);
	            $swindow->add($self->{'STATUS_TEXT'});
	            $self->{'STATUS_TEXT'}->show();
	          $swindow->show();
	        $hbox->set_child_packing($swindow,1,1,0,"start");
	        $hbox->show();

	      $packer->show();
	    $frame->show();
	  $vbox->add($frame);
	  $vbox->set_child_packing($frame,0,1,1,"start");
	    $notebook = new Gtk::Notebook;
	    $notebook->can_focus(1);
	    $notebook->border_width(5);
#	    $notebook->set_usize(0,300);
	    $notebook->set_tab_pos("top");
	    $notebook->set_show_tabs(1);
	    $notebook->set_show_border(1);
	    $notebook->set_scrollable(0);
	    $notebook->set_tab_hborder(2);
	    $notebook->set_tab_vborder(2);
	      $frame = new Gtk::Frame();
	      $frame->set_label_align(0,0);
	      $frame->set_shadow_type('etched_in');
	      $frame->border_width(6);
	        $packer = new Gtk::Packer();
	        $packer->set_default_border_width(0);
	        $packer->set_default_pad(0,0);
	        $packer->set_default_ipad(0,0);
	        $packer->border_width(5);
	          my $notebook_vbox = new Gtk::VBox(FALSE,FALSE);        
		  $packer->add_defaults($notebook_vbox,"top","north_west",["expand","fill_x","fill_y"]);
	            my $notebook_hbox = new Gtk::HBox(FALSE,FALSE);
	              $label = new Gtk::Label("Search :");
	              $label->set_justify("center");
	              $label->set_line_wrap(0);
	              $label->set_alignment(0.5,0.5);
	              $label->set_padding(5,2);
	              $notebook_hbox->add($label);
	              $notebook_hbox->set_child_packing($label,0,0,0,"start");
	              $label->show();
	
	              $self->{'SEACH_ENTRY'} = new Gtk::Entry();
	              $self->{'SEACH_ENTRY'}->can_focus(1);
	              $self->{'SEACH_ENTRY'}->set_max_length(0);
	              $self->{'SEACH_ENTRY'}->set_visibility(TRUE);
	              $self->{'SEACH_ENTRY'}->set_editable(TRUE);
	              $notebook_hbox->add($self->{'SEACH_ENTRY'});
	              $notebook_hbox->set_child_packing($label,0,0,0,"start");
	              $self->{'SEACH_ENTRY'}->show();
	            $notebook_vbox->add($notebook_hbox);
	            $notebook_vbox->set_child_packing($notebook_hbox,0,0,0,"start");
	            $notebook_hbox->show();

	            $sbar = new Gtk::ScrolledWindow( undef, undef);
	            $sbar->set_policy("automatic","always");
	            $sbar->border_width(0);
	            $sbar->hscrollbar->set_update_policy("continuous");
	            $sbar->vscrollbar->set_update_policy("continuous");
	              $self->{'OFFER_CLIST'} = new_with_titles Gtk::CList("Network","Bot","Pack","Slots","Queue","Size","Description");
	              $self->{'OFFER_CLIST'}->set_selection_mode("extended");
	              $self->{'OFFER_CLIST'}->set_border("in");
	              $self->{'OFFER_CLIST'}->set_column_justification(OFFER_CLIST_SLOTS,"center"); 
	              $self->{'OFFER_CLIST'}->set_column_justification(OFFER_CLIST_QUEUE,"center"); 
	              $self->{'OFFER_CLIST'}->set_column_justification(OFFER_CLIST_SIZE,"right"); 
	              $self->{'OFFER_CLIST'}->column_titles_show();
	              $self->{'OFFER_CLIST'}->set_column_width(OFFER_CLIST_NETWORK,70);
	              $self->{'OFFER_CLIST'}->set_column_width(OFFER_CLIST_BOT,70);
	              $self->{'OFFER_CLIST'}->set_column_width(OFFER_CLIST_PACK,30);
	              $self->{'OFFER_CLIST'}->set_column_width(OFFER_CLIST_SLOTS,40);
	              $self->{'OFFER_CLIST'}->set_column_width(OFFER_CLIST_QUEUE,40);
	              $self->{'OFFER_CLIST'}->set_column_width(OFFER_CLIST_SIZE,35);
	              $self->{'OFFER_CLIST'}->set_column_width(OFFER_CLIST_DESCRIPTION,80);
	              $self->{'OFFER_CLIST'}->set_sort_column(OFFER_CLIST_DEFAULT_SORT);
	              $self->{'OFFER_CLIST'}->can_focus(TRUE);

	              $notebook_vbox->set_child_packing($sbar,1,1,0,"start");
	              $self->{'OFFER_CLIST'}->show();
	              $sbar->add($self->{'OFFER_CLIST'});
	            $notebook_vbox->add($sbar);
	            $sbar->show();
		  $notebook_vbox->show();
		$frame->add($packer);
	        $packer->show();
	      $frame->show();
	      $label = new Gtk::Label("Offers");
	      $label->show();
	    $notebook->append_page($frame,$label);
	      $frame = new Gtk::Frame();
	      $frame->set_label_align(0,0);
	      $frame->set_shadow_type('etched_in');
	      $frame->border_width(6);
	        $packer = new Gtk::Packer();
	        $packer->set_default_border_width(0);
	        $packer->set_default_pad(0,0);
	        $packer->set_default_ipad(0,0);
	        $packer->border_width(5);
	          my $notebook_vbox = new Gtk::VBox(FALSE,FALSE);        
		  $packer->add_defaults($notebook_vbox,"top","north_west",["expand","fill_x","fill_y"]);

	            $sbar = new Gtk::ScrolledWindow( undef, undef);
	            $sbar->set_policy("automatic","always");
	            $sbar->border_width(0);
	            $sbar->hscrollbar->set_update_policy("continuous");
	            $sbar->vscrollbar->set_update_policy("continuous");
	              $self->{'QUEUE_CLIST'} = new_with_titles Gtk::CList("Network","Bot","Pack","Queue State","Description");
	              $self->{'QUEUE_CLIST'}->set_selection_mode("extended");
	              $self->{'QUEUE_CLIST'}->set_border("in");
	              $self->{'QUEUE_CLIST'}->column_titles_show();
	              $self->{'QUEUE_CLIST'}->set_column_width(QUEUE_CLIST_NETWORK,70);
	              $self->{'QUEUE_CLIST'}->set_column_width(QUEUE_CLIST_BOT,70);
	              $self->{'QUEUE_CLIST'}->set_column_width(QUEUE_CLIST_PACK,30);
	              $self->{'QUEUE_CLIST'}->set_column_width(QUEUE_CLIST_STATE,100);
	              $self->{'QUEUE_CLIST'}->set_column_width(QUEUE_CLIST_DESCRIPTION,80);
	              $self->{'QUEUE_CLIST'}->set_sort_column(QUEUE_CLIST_DEFAULT_SORT);
	              $self->{'QUEUE_CLIST'}->can_focus(TRUE);

	              $notebook_vbox->set_child_packing($sbar,1,1,0,"start");
	              $self->{'QUEUE_CLIST'}->show();
	              $sbar->add($self->{'QUEUE_CLIST'});
	            $notebook_vbox->add($sbar);
	            $sbar->show();
		  $notebook_vbox->show();
		$frame->add($packer);
	        $packer->show();
	      $frame->show();
	      $label = new Gtk::Label("Queue");
	      $label->show();
	    $notebook->append_page($frame,$label);
	      $frame = new Gtk::Frame();
	      $frame->set_label_align(0,0);
	      $frame->set_shadow_type('etched_in');
	      $frame->border_width(6);
	        $packer = new Gtk::Packer();
	        $packer->set_default_border_width(0);
	        $packer->set_default_pad(0,0);
	        $packer->set_default_ipad(0,0);
	        $packer->border_width(5);
	          my $notebook_vbox = new Gtk::VBox(FALSE,FALSE);        
		  $packer->add_defaults($notebook_vbox,"top","north_west",["expand","fill_x","fill_y"]);

	            $sbar = new Gtk::ScrolledWindow( undef, undef);
	            $sbar->set_policy("automatic","always");
	            $sbar->border_width(0);
	            $sbar->hscrollbar->set_update_policy("continuous");
	            $sbar->vscrollbar->set_update_policy("continuous");
	              $self->{'DCC_CLIST'} = new_with_titles Gtk::CList("ID","Bot","File","Size","Percent","Speed","ETA");
	              $self->{'DCC_CLIST'}->set_selection_mode("extended");
	              $self->{'DCC_CLIST'}->set_border("in");
	              $self->{'DCC_CLIST'}->column_titles_show();
	              $self->{'DCC_CLIST'}->set_column_width(DCC_CLIST_ID,11);
	              $self->{'DCC_CLIST'}->set_column_width(DCC_CLIST_BOT,100);
	              $self->{'DCC_CLIST'}->set_column_width(DCC_CLIST_FILE,320);
	              $self->{'DCC_CLIST'}->set_column_width(DCC_CLIST_SIZE,80);
	              $self->{'DCC_CLIST'}->set_column_width(DCC_CLIST_PERCENT,40);
	              $self->{'DCC_CLIST'}->set_column_width(DCC_CLIST_SPEED,40);
	              $self->{'DCC_CLIST'}->set_column_width(DCC_CLIST_ETA,40);
	              $self->{'DCC_CLIST'}->set_sort_column(DCC_CLIST_DEFAULT_SORT);
	              $self->{'DCC_CLIST'}->can_focus(TRUE);

	              $notebook_vbox->set_child_packing($sbar,1,1,0,"start");
	              $self->{'DCC_CLIST'}->show();
	              $sbar->add($self->{'DCC_CLIST'});
	            $notebook_vbox->add($sbar);
	            $sbar->show();
		  $notebook_vbox->show();
		$frame->add($packer);
	        $packer->show();
	      $frame->show();
	      $label = new Gtk::Label("Transfers");
	      $label->show();
	    $notebook->append_page($frame,$label);
	      $frame = new Gtk::Frame();
	      $frame->set_label_align(0,0);
	      $frame->set_shadow_type('etched_in');
	      $frame->border_width(6);
	        $packer = new Gtk::Packer();
	        $packer->set_default_border_width(0);
	        $packer->set_default_pad(0,0);
	        $packer->set_default_ipad(0,0);
	        $packer->border_width(5);
	          my $notebook_vbox = new Gtk::VBox(FALSE,FALSE);        
		  $packer->add_defaults($notebook_vbox,"top","north_west",["expand","fill_x","fill_y"]);

	            $self->{'NETWORK_SWINDOW'} = new Gtk::ScrolledWindow( undef, undef);
	            $self->{'NETWORK_SWINDOW'}->set_policy("automatic","always");
	            $self->{'NETWORK_SWINDOW'}->border_width(0);
	            $self->{'NETWORK_SWINDOW'}->hscrollbar->set_update_policy("continuous");
	            $self->{'NETWORK_SWINDOW'}->vscrollbar->set_update_policy("continuous");
	              $self->{'NETWORK_CLIST'} = new_with_titles Gtk::CList("Network","Status","Channels","Info");
	              $self->{'NETWORK_CLIST'}->set_selection_mode("extended");
	              $self->{'NETWORK_CLIST'}->set_border("in");
	              $self->{'NETWORK_CLIST'}->column_titles_show();
	              $self->{'NETWORK_CLIST'}->set_column_width(NETWORK_CLIST_NETWORK,80);
	              $self->{'NETWORK_CLIST'}->set_column_width(NETWORK_CLIST_STATUS,180);
	              $self->{'NETWORK_CLIST'}->set_column_width(NETWORK_CLIST_CHANNELS,60);
	              $self->{'NETWORK_CLIST'}->set_column_width(NETWORK_CLIST_INFO,100);
	              $self->{'NETWORK_CLIST'}->set_column_justification(NETWORK_CLIST_CHANNELS,"center"); 
	              $self->{'NETWORK_CLIST'}->set_sort_column(NETWORK_CLIST_DEFAULT_SORT);
	              $self->{'NETWORK_CLIST'}->can_focus(TRUE);

	              $self->{'NETWORK_SWINDOW'}->add($self->{'NETWORK_CLIST'});
	              $notebook_vbox->set_child_packing($self->{'NETWORK_SWINDOW'},1,1,0,"start");
	              $self->{'NETWORK_CLIST'}->show();
	            $notebook_vbox->add($self->{'NETWORK_SWINDOW'});
	            $self->{'NETWORK_SWINDOW'}->show();
		  $notebook_vbox->show();
		$frame->add($packer);
	        $packer->show();
	      $frame->show();
	      $label = new Gtk::Label("Networks");
	      $label->show();
	    $notebook->append_page($frame,$label);
	      $frame = new Gtk::Frame();
	      $frame->set_label_align(0,0);
	      $frame->set_shadow_type('etched_in');
	      $frame->border_width(6);
	        $packer = new Gtk::Packer();
	        $packer->set_default_border_width(0);
	        $packer->set_default_pad(0,0);
	        $packer->set_default_ipad(0,0);
	        $packer->border_width(5);
	          my $notebook_vbox = new Gtk::VBox(FALSE,FALSE);        
		  $packer->add_defaults($notebook_vbox,"top","north_west",["expand","fill_x","fill_y"]);

	            $sbar = new Gtk::ScrolledWindow( undef, undef);
	            $sbar->set_policy("automatic","always");
	            $sbar->border_width(0);
	            $sbar->hscrollbar->set_update_policy("continuous");
	            $sbar->vscrollbar->set_update_policy("continuous");
	              $self->{'CHANNELS_CLIST'} = new_with_titles Gtk::CList("Network","Channel","Status","Topic");
	              $self->{'CHANNELS_CLIST'}->set_selection_mode("extended");
	              $self->{'CHANNELS_CLIST'}->set_border("in");
	              $self->{'CHANNELS_CLIST'}->column_titles_show();
	              $self->{'CHANNELS_CLIST'}->set_column_width(CHANNEL_CLIST_NETWORK,70);
	              $self->{'CHANNELS_CLIST'}->set_column_width(CHANNEL_CLIST_CHANNEL,70);
	              $self->{'CHANNELS_CLIST'}->set_column_width(CHANNEL_CLIST_STATUS,70);
	              $self->{'CHANNELS_CLIST'}->set_column_width(CHANNEL_CLIST_TOPIC,40);
	              $self->{'CHANNELS_CLIST'}->set_sort_column(CHANNEL_CLIST_DEFAULT_SORT);
	              $self->{'CHANNELS_CLIST'}->can_focus(TRUE);

	              $notebook_vbox->set_child_packing($sbar,1,1,0,"start");
	              $self->{'CHANNELS_CLIST'}->show();
	              $sbar->add($self->{'CHANNELS_CLIST'});
	            $notebook_vbox->add($sbar);
	            $sbar->show();
		  $notebook_vbox->show();
		$frame->add($packer);
	        $packer->show();
	      $frame->show();
	      $label = new Gtk::Label("Channels");
	      $label->show();
	    $notebook->append_page($frame,$label);

	    $vbox->add($notebook);
	    $notebook->show();
	  $vbox->set_child_packing($notebook,1,1,0,"start");
	    $self->{'STATUS_BAR'} = new Gtk::Statusbar;
	    $vbox->add($self->{'STATUS_BAR'});
	    $self->{'STATUS_BAR'}->show();
	  $vbox->set_child_packing($self->{'STATUS_BAR'},0,0,0,"start");
	  $self->{'WINDOW'}->add($vbox);
	  $vbox->show();
	$self->{'WINDOW'}->show();

	# popup for offer clist
	$self->{'OFFER_POPUP'}->{'MENU'} = new Gtk::Menu();
	  $self->{'OFFER_POPUP'}->{'TITLE'} = new Gtk::MenuItem();
	  $self->{'OFFER_POPUP'}->{'REQUEST'} = new Gtk::MenuItem("Request");
	  $self->{'OFFER_POPUP'}->{'SELECT_ALL'} = new Gtk::MenuItem("Select All");
	  $self->{'OFFER_POPUP'}->{'UNSELECT_ALL'} = new Gtk::MenuItem("Unselect ALL");
	  $self->{'OFFER_POPUP'}->{'PURGE'} = new Gtk::MenuItem("Purge Old");
	  $self->{'OFFER_POPUP'}->{'MENU'}->append($self->{'OFFER_POPUP'}->{'TITLE'});
	  $self->{'OFFER_POPUP'}->{'MENU'}->append($self->{'OFFER_POPUP'}->{'REQUEST'});
	  $self->{'OFFER_POPUP'}->{'MENU'}->append($self->{'OFFER_POPUP'}->{'SELECT_ALL'});
	  $self->{'OFFER_POPUP'}->{'MENU'}->append($self->{'OFFER_POPUP'}->{'UNSELECT_ALL'});
	  $self->{'OFFER_POPUP'}->{'MENU'}->append($self->{'OFFER_POPUP'}->{'PURGE'});
	  $self->{'OFFER_POPUP'}->{'PURGE'}->show();
	  $self->{'OFFER_POPUP'}->{'SELECT_ALL'}->show();
	  $self->{'OFFER_POPUP'}->{'UNSELECT_ALL'}->show();
	  $self->{'OFFER_POPUP'}->{'REQUEST'}->show();
	  $self->{'OFFER_POPUP'}->{'TITLE'}->show();

	# popup for queue clist
	$self->{'QUEUE_POPUP'}->{'MENU'} = new Gtk::Menu();
	  $self->{'QUEUE_POPUP'}->{'CANCEL'} = new Gtk::MenuItem("Cancel");
	  $self->{'QUEUE_POPUP'}->{'SELECT_ALL'} = new Gtk::MenuItem("Select All");
	  $self->{'QUEUE_POPUP'}->{'UNSELECT_ALL'} = new Gtk::MenuItem("Unselect ALL");
	  $self->{'QUEUE_POPUP'}->{'MENU'}->append($self->{'QUEUE_POPUP'}->{'CANCEL'});
	  $self->{'QUEUE_POPUP'}->{'MENU'}->append($self->{'QUEUE_POPUP'}->{'SELECT_ALL'});
	  $self->{'QUEUE_POPUP'}->{'MENU'}->append($self->{'QUEUE_POPUP'}->{'UNSELECT_ALL'});
	  $self->{'QUEUE_POPUP'}->{'SELECT_ALL'}->show();
	  $self->{'QUEUE_POPUP'}->{'UNSELECT_ALL'}->show();
	  $self->{'QUEUE_POPUP'}->{'CANCEL'}->show();

	# popup for dcc clist
	$self->{'DCC_POPUP'}->{'MENU'} = new Gtk::Menu();
	  $self->{'DCC_POPUP'}->{'STOP'} = new Gtk::MenuItem("Stop");
	  $self->{'DCC_POPUP'}->{'STOP_DELETE'} = new Gtk::MenuItem("Stop & Delete");
	  $self->{'DCC_POPUP'}->{'SELECT_ALL'} = new Gtk::MenuItem("Select All");
	  $self->{'DCC_POPUP'}->{'UNSELECT_ALL'} = new Gtk::MenuItem("Unselect ALL");
	  $self->{'DCC_POPUP'}->{'MENU'}->append($self->{'DCC_POPUP'}->{'STOP'});
	  $self->{'DCC_POPUP'}->{'MENU'}->append($self->{'DCC_POPUP'}->{'STOP_DELETE'});
	  $self->{'DCC_POPUP'}->{'MENU'}->append($self->{'DCC_POPUP'}->{'SELECT_ALL'});
	  $self->{'DCC_POPUP'}->{'MENU'}->append($self->{'DCC_POPUP'}->{'UNSELECT_ALL'});
	  $self->{'DCC_POPUP'}->{'SELECT_ALL'}->show();
	  $self->{'DCC_POPUP'}->{'UNSELECT_ALL'}->show();
	  $self->{'DCC_POPUP'}->{'STOP_DELETE'}->show();
	  $self->{'DCC_POPUP'}->{'STOP'}->show();

	# popup for network clist
	$self->{'NETWORK_POPUP'}->{'MENU'} = new Gtk::Menu();
	  $self->{'NETWORK_POPUP'}->{'ENABLE'} = new Gtk::MenuItem("Re-Enable");
	  $self->{'NETWORK_POPUP'}->{'MENU'}->append($self->{'NETWORK_POPUP'}->{'ENABLE'});
	  $self->{'NETWORK_POPUP'}->{'ENABLE'}->show();

	# popup for channel clist
	$self->{'CHANNEL_POPUP'}->{'MENU'} = new Gtk::Menu();
	  $self->{'CHANNEL_POPUP'}->{'JOIN'} = new Gtk::MenuItem("Join");
	  $self->{'CHANNEL_POPUP'}->{'MENU'}->append($self->{'CHANNEL_POPUP'}->{'JOIN'});
	  $self->{'CHANNEL_POPUP'}->{'JOIN'}->show();


	bless $self;

}


sub get_window {
	my ($self) = @_;
	return($self->{'WINDOW'});
}

sub get_file_menu {
	my ($self) = @_;
	return($self->{'FILE_MENU'});
}
sub get_offer_popup {
	my ($self) = @_;
	return($self->{'OFFER_POPUP'});	
}

sub get_queue_popup {
	my ($self) = @_;
	return($self->{'QUEUE_POPUP'});
}
sub get_dcc_popup {
	my ($self) = @_;
	return($self->{'DCC_POPUP'});
}
sub get_network_popup {
	my ($self) = @_;
	return($self->{'NETWORK_POPUP'});
}
sub get_channel_popup {
	my ($self) = @_;
	return($self->{'CHANNEL_POPUP'});
}

sub get_status_text {
	my ($self) = @_;
	return($self->{'STATUS_TEXT'});
}

sub get_status_bar {
	my ($self) = @_;
	return($self->{'STATUS_BAR'});
}

sub get_search_entry {
	my ($self) = @_;
	return($self->{'SEACH_ENTRY'});
}
sub get_offer_clist {
	my ($self) = @_;
	return($self->{'OFFER_CLIST'});
}

sub get_queue_clist {
	my ($self) = @_;
	return($self->{'QUEUE_CLIST'});
}

sub get_dcc_clist {
	my ($self) = @_;
	return($self->{'DCC_CLIST'});
}
sub get_network_clist {
	my ($self) = @_;
	return($self->{'NETWORK_CLIST'});
}

sub get_network_swindow {
	my ($self) = @_;
	return($self->{'NETWORK_SWINDOW'});
}
sub get_channel_clist {
	my ($self) = @_;
	return($self->{'CHANNELS_CLIST'});
}

1;
