package XButtler::Log;
use strict;
use IO::File;
use XButtler::Common;

sub DESTROY {
	my $self = shift;
	$self->{FH}->close();
}

sub new {
	my ($class,%args) = @_;
	my $self = {};	

	my $file = $args{'File'};
	my $append = $args{'Append'};

	my $openmode;
	if($append == TRUE) {
		$openmode = ">>";
	} else {
		$openmode = ">";
	}

	$self->{FH} = IO::File->new("$openmode$file");

	if(!defined($self->{FH})) {
		print "$!\n";
		return undef;
	}

	autoflush {$self->{FH}} 1;
	bless $self;
	$self->write("** XButter::Log - Start **");
	return $self;
}


sub write {
	my ($self,$line) = @_;

	my ($sec,$min,$hour) = (localtime())[0,1,2];
	my $fh = $self->{FH};
	
	my $line = sprintf("[%#.2d:%#.2d.%#.2d] %s",$hour,$min,$sec,$line);
	printf {$self->{FH}} "$line\n";

}

1;
